<script type="text/javascript">
    var ttSmtpProto = 'Enables SMTP service. If you disable it, mail clients and other mail servers won\'t be able to send e-mails to your mail server.';
    var ttSmtpPort = 'Mail clients and other mail servers use this port to establish regular SMTP connections with your mail server. If enabled, make sure the port is opened in your firewall.';
    var ttSmtpPortSSL = 'Mail clients use this port to establish secure SMTP connections with your mail server. Set it blank to disable SSL/TLS connections. If enabled, make sure the port is opened in your firewall.';
    var ttEnableSMTP_TLS = 'Enables making secure SSL/TLS connections via regular SMTP port. If enabled, mail clients can turn the regular connection into secure with STARTTLS command.';
    var ttEnableAuthSMTP_POP3 = 'If enabled, mail clients can authenticate on the SMTP server, first connecting to the POP3 service with the user credentials, and then immediately connecting to the SMTP service. This method is used by some older mail clients which do not support ESMTP authentication and thus cannot send the user credentials to the SMTP server.';
    var ttSmtpGwConfig = 'A comma-separated list of variable=value definitions for tuning how SMTP gateways communicate with each other. NeedTLS=1 means trying to establish a secure connection, if it fails, a non-secure connection will be established.  NeedTLS=2 - try to establish a secure connection, if it fails, there wont be an attempt of non-secure connection. OutBind sets IP address of network interface used to connect to remote host (local endpoint).';
    var ttDefaultSMTPGateways = 'If you specify one or more SMTP gateways (a comma separated list of SMTP server addresses), XMail will send all messages through those servers (if the first server is dead, the second will be used, etc). This is useful for XMail installations inside a local network when XMail has no MX record assigned or XMail doesn\'t have access to a DNS server to resolve MX records.';
    var ttSmtpConfig = 'If enabled, any SMTP agent (no matter SMTP server or mail client) MUST authenticate to send messages to both local and foreign domains. If disabled, SMTP authentication is required only for sending to foreign domains (relay).';
    var ttAllowSmtpVRFY = 'Obsolete command. Most SMTP servers have it disabled nowadays. Used for validating sender addresses.';
    var ttMaxMessageSize = 'Maximum size of message your mail server accepts (in KB). Messages with greater size are rejected.';
</script>
<form action="<?php echo AP_INDEX_FILE;?>?mode=submit" method="POST" id="smtp_form" <?php $this->data->PrintValue('hideClass_smtp') ?>>
<input type="hidden" name="form_id" value="smtp">
<table class="wm_admin_center" width="650" cellpadding="0" cellspacing="0">
	<tr>
		<td width="200"></td>
		<td><br /></td>
	</tr>
	<tr>
		<td class="wm_safety_info" colspan="2">
			Configures how your mail server exchanges e-mails through SMTP protocol
			(read more on&nbsp;<a href="http://en.wikipedia.org/wiki/SMTP" target="_blank">Wikipedia</a>).
		</td>
	</tr>
	<tr><td colspan="2"><br /></td></tr>
	<tr>
		<td colspan="2" class="wm_admin_title">
			 SMTP Options
		</td>
	</tr>
	<tr>
		<td>
			* <label class="LabelOffset DottedText" for="box_SmtpProto" onmouseover="AddToolTip(ttSmtpProto);"
				onmouseout="RemoveToolTip();">Enable SMTP</label>
		</td>
		<td>
			<input name="box_SmtpProto" class="wm_checkbox" value="1" type="checkbox" id="box_SmtpProto" <?php $this->data->PrintCheckedValue('box_SmtpProto') ?>/>
		</td>
	</tr>
	<tr>
		<td>
			* <span class="LabelOffset DottedText" onmouseover="AddToolTip(ttSmtpPort);"
				onmouseout="RemoveToolTip();">SMTP server port</span>
		</td>
		<td>
			<input name="var_SmtpPort" type="text" id="var_SmtpPort" class="wm_input wm_addmargin" maxlength="5" style="width: 300px;" value="<?php $this->data->PrintIntValue('var_SmtpPort') ?>" />
		</td>
	</tr>
	<tr>
		<td>
			* <span class="LabelOffset DottedText" onmouseover="AddToolTip(ttSmtpPortSSL);"
				onmouseout="RemoveToolTip();">SMTP/SSL/TLS server port</span>
		</td>
		<td>
			<input name="var_SmtpPortSSL" type="text" id="var_SmtpPortSSL" class="wm_input wm_addmargin" maxlength="5" style="width: 300px;" value="<?php $this->data->PrintIntValue('var_SmtpPortSSL') ?>" />
		</td>
	</tr>
	<tr>
		<td>
			<label class="LabelOffset DottedText" for="box_EnableSMTP_TLS" onmouseover="AddToolTip(ttEnableSMTP_TLS);"
				onmouseout="RemoveToolTip();">Enable SMTP STARTTLS</label>
		</td>
		<td>
			<input name="box_EnableSMTP_TLS" class="wm_checkbox" value="1" type="checkbox" id="box_EnableSMTP_TLS" <?php $this->data->PrintCheckedValue('box_EnableSMTP_TLS') ?>/>
		</td>
	</tr>
	<tr>
		<td>
			<label class="LabelOffset DottedText" for="box_EnableAuthSMTP_POP3" onmouseover="AddToolTip(ttEnableAuthSMTP_POP3);"
				onmouseout="RemoveToolTip();">Enable POP3 before SMTP auth</label>
		</td>
		<td>
			<input name="box_EnableAuthSMTP_POP3" class="wm_checkbox" value="1" type="checkbox" id="box_EnableAuthSMTP_POP3" <?php $this->data->PrintCheckedValue('box_EnableAuthSMTP_POP3') ?>/>
		</td>
	</tr>
	<tr>
		<td>
			<input name="var_DefaultSmtpPerms" type="hidden" id="var_DefaultSmtpPerms" value="<?php $this->data->PrintInputValue('var_DefaultSmtpPerms') ?>" />
			<input name="check_MaxMessageSize" type="checkbox" value="1" class="wm_checkbox" id="check_MaxMessageSize" <?php $this->data->PrintCheckedValue('check_MaxMessageSize') ?>/>
			<label class="XBoxOffset DottedText" style="margin-left: 2px;" for="check_MaxMessageSize" onmouseover="AddToolTip(ttMaxMessageSize);"
					onmouseout="RemoveToolTip();">Max message size</label>
		</td>
		<td>
			<input name="var_MaxMessageSize" type="text" id="var_MaxMessageSize" class="wm_input wm_addmargin" style="width: 250px" value="<?php $this->data->PrintIntValue('var_MaxMessageSize') ?>" />
            &nbsp;KB
		</td>
	</tr>
	<tr <?php $this->data->PrintValue('class_Advanced') ?>>
		<td colspan="2">
			<div class="convoluted">
				<div onclick="advSwitch(this)">Advanced Options</div>
				<table cellspacing="0" cellpadding="0">
					<tr>
						<td width="220">
							&nbsp;
						 	<input name="check_SmtpGwConfig" value="1" type="checkbox" class="wm_checkbox" id="check_SmtpGwConfig" <?php $this->data->PrintCheckedValue('check_SmtpGwConfig') ?>/>
						 	&nbsp;
							<label class="XBoxOffset DottedText" for="check_SmtpGwConfig" onmouseover="AddToolTip(ttSmtpGwConfig);"
									onmouseout="RemoveToolTip();">SMTP global gateway options</label>
						</td>
						<td>
							<input value="SmtpGlobalGatewayOptionsDefaultRadioID" class="wm_checkbox" name="SmtpGlobalGatewayOptionsName" type="radio" id="SmtpGlobalGatewayOptionsDefaultRadioID" <?php $this->data->PrintCheckedValue('SmtpGlobalGatewayOptionsDefaultRadioID') ?>/>
							&nbsp;
							<label class="XBoxOffset" for="SmtpGlobalGatewayOptionsDefaultRadioID">Default</label>
							<br />
							<input value="SmtpGlobalGatewayOptionsCustomRadioID" class="wm_checkbox" name="SmtpGlobalGatewayOptionsName" type="radio" id="SmtpGlobalGatewayOptionsCustomRadioID" <?php $this->data->PrintCheckedValue('SmtpGlobalGatewayOptionsCustomRadioID') ?>/>
							&nbsp;
							<label class="XBoxOffset" for="SmtpGlobalGatewayOptionsCustomRadioID">Custom</label>
							&nbsp;
							<input name="var_SmtpGwConfig" type="text" id="var_SmtpGwConfig" class="wm_input" style="width: 200px;" value="<?php $this->data->PrintInputValue('var_SmtpGwConfig') ?>" />
						</td>
					</tr>
					<tr>
						<td>
							&nbsp;
						 	<input name="check_DefaultSMTPGateways" value="1" class="wm_checkbox" type="checkbox" id="check_DefaultSMTPGateways" <?php $this->data->PrintCheckedValue('check_DefaultSMTPGateways') ?>/>
						 	&nbsp;
							<label class="XBoxOffset DottedText" for="check_DefaultSMTPGateways" onmouseover="AddToolTip(ttDefaultSMTPGateways);"
									onmouseout="RemoveToolTip();">Default SMTP MX gateways list</label>
						</td>
						<td>
							<input value="DefaultSmtpGatewayListDefaultRadioID" name="DefaultSmtpGatewayListName" class="wm_checkbox" type="radio" id="DefaultSmtpGatewayListDefaultRadioID" <?php $this->data->PrintCheckedValue('DefaultSmtpGatewayListDefaultRadioID') ?>/>
							&nbsp;
							<label class="XBoxOffset" for="DefaultSmtpGatewayListDefaultRadioID">Default</label>
							<br />
							<input value="DefaultSmtpGatewayListCustomRadioID" name="DefaultSmtpGatewayListName" type="radio" class="wm_checkbox" id="DefaultSmtpGatewayListCustomRadioID" <?php $this->data->PrintCheckedValue('DefaultSmtpGatewayListCustomRadioID') ?>/>
							&nbsp;
							<label class="XBoxOffset" for="DefaultSmtpGatewayListCustomRadioID">Custom</label>
							&nbsp;
							<input name="var_DefaultSMTPGateways" type="text" id="var_DefaultSMTPGateways" class="wm_input" style="width: 200px;" value="<?php $this->data->PrintInputValue('var_DefaultSMTPGateways') ?>" />
						</td>
					</tr>
					<tr>
						<td>
							&nbsp;
						 	<input name="check_SmtpConfig" value="1" type="checkbox" class="wm_checkbox" id="check_SmtpConfig" <?php $this->data->PrintCheckedValue('check_SmtpConfig') ?>/>
							&nbsp;
							<label class="XBoxOffset DottedText" for="check_SmtpConfig" onmouseover="AddToolTip(ttSmtpConfig);"
									onmouseout="RemoveToolTip();">SMTP auth</label>						
						</td>
						<td>
							<input value="SmtpAuthDefaultRadioID" name="SmtpAuthName" class="wm_checkbox" type="radio" id="SmtpAuthDefaultRadioID" <?php $this->data->PrintCheckedValue('SmtpAuthDefaultRadioID') ?>/>
							&nbsp;
							<label class="XBoxOffset" for="SmtpAuthDefaultRadioID">On</label>
							<br />
							<input value="SmtpAuthCustomRadioID" name="SmtpAuthName" class="wm_checkbox" type="radio" id="SmtpAuthCustomRadioID" <?php $this->data->PrintCheckedValue('SmtpAuthCustomRadioID') ?>/>
							&nbsp;
							<label class="XBoxOffset" for="SmtpAuthCustomRadioID">Custom</label>
							&nbsp;
							<input name="var_SmtpConfig" type="text" id="var_SmtpConfig" class="wm_input" style="width: 200px;" value="<?php $this->data->PrintInputValue('var_SmtpConfig') ?>" />
						</td>
					</tr>
					<tr>
						<td colspan="2">
							&nbsp;
							<input name="box_AllowSmtpVRFY" value="1" type="checkbox" class="wm_checkbox" id="box_AllowSmtpVRFY" <?php $this->data->PrintCheckedValue('box_AllowSmtpVRFY') ?>/>
							&nbsp;
							<label class="XBoxOffset DottedText" for="box_AllowSmtpVRFY" onmouseover="AddToolTip(ttAllowSmtpVRFY);"
									onmouseout="RemoveToolTip();">Enable VRFY SMTP command</label>
						</td>
					</tr>
				</table>
			</div>
		</td>
	</tr>
	<tr><td colspan="2"><hr size="1"></td></tr>
	<tr>
		<td colspan="2" align="right">
			<span class="wm_secondary_info" style="float: left; text-align: left;">* changing settings marked with asterisks<br />requires <a href="#" onclick="PopupDiv.Show();">manual restart of "AfterLogic XMail Server" service</a>.</span>
			<input type="submit" name="submit_btn" value="Save" class="wm_button" style="width: 100px">
		</td>
	</tr>
</table>
</form>