<?php

/*
 * AfterLogic WebMail Pro PHP by AfterLogic Corp. <support@afterlogic.com>
 *
 * Copyright (C) 2002-2009  AfterLogic Corp. (www.afterlogic.com)
 * Distributed under the terms of the proprietary AfterLogic Computer License (LICENSE.txt)
 * 
 */

if (!defined('WM_ROOTPATH')) define('WM_ROOTPATH', (dirname(__FILE__).'/'));

require_once(WM_ROOTPATH.'class_settings.php');
require_once(WM_ROOTPATH.'calendar/class_settings.php');

$wm_settings =& Settings::CreateInstance();
$settings = new CalSettings($wm_settings);

if ($settings->DbType  == DB_MYSQL)
{
	include_once("db_mysql.php");
}
else if ($settings->DbType == DB_MSSQLSERVER) 
{
	include_once("db_mssql.php");
}
else
{
	exit('Can\'t get settings');
}
//$host = $settings->DbHost;

class SQL
{
		//static $db;
		function init($host, $login, $password, $dbname)
		{
			$db = new DB();
			return $db->connect($host, $login, $password, $dbname);
		}

		function Select($prefix, $Table, $Name, $Value)
		{
			if($Table == 'acal_events')
				return DB::query("SELECT *,".DB::convert_date_as("event_timefrom").",".DB::convert_date_as("event_timetill")." FROM ".$prefix.$Table." WHERE ".$Name."=".(DB::escape($Value))."");
			else
				return DB::query("SELECT * FROM ".$prefix.$Table." WHERE ".$Name."=".(DB::escape($Value))."");
		}

		function InsertUpdateByID($prefix, $Table, &$ID, $Name, $Array)
		{
			if ($ID == 0)
			{
					$data   = array(); 
					$values = array();
					foreach($Array as $Key=>$Val)
					{
							$data[]   = $Key;
							if(substr($Key,'time') === true)
								$values[] = "'".DB::convert_date(DB::escape($Val))."'";
							else
								$values[] = "'".DB::escape($Val)."'";
					}

					$res    = implode(', ', $data);
					$result = implode(', ', $values);        
					$ID = DB::executeWithId("INSERT INTO ".$prefix.$Table." (".$res.") VALUES(".$result.")");
					return $ID;
			}
			else
			{
					$data   = array(); 
					$values = array();

					foreach($Array as $Key=>$Val)
					{
							if(substr($Key,'time') === true)
								$data[] = $Key."= ".DB::convert_date(DB::escape($Val))."";
							else
								$data[] = $Key."= '".DB::escape($Val)."'";
					}
					$res = implode(', ', $data);
					return DB::execute("UPDATE ".$prefix.$Table." SET ".$res." WHERE ".$Name." =".$ID);
			}
		}

		function InsertUpdate($prefix, &$ID, $Calendar, $Array)
		{
			if($ID == 0)
			{
					$data   = array(); 
					$values = array();

					foreach($Array as $Key=>$Arr)
					{
							$data[]   = $Key;
							if(substr($Key,'time') === true)
								$values[] = "'".DB::convert_date(DB::escape($Arr))."'";
							else
								$values[] = "'".DB::escape($Arr)."'";
					}

					$res    = implode(', ', $data);
					$result = implode(', ', $values);

					$ID = DB::executeWithId("INSERT INTO ".$prefix."acal_events (".$res.") VALUES(".$result.")");
					return $ID;
			}
			else
			{
					$data   = array(); 
					$values = array();

					foreach($Array as $Key=>$Arr)
					{
							if(substr($Key,'time') === true)
								$data[] = $Key."= ".DB::convert_date(DB::escape($Arr))."";
							else
								$data[] = $Key."= '".DB::escape($Arr)."'";
					}

					$res = implode(', ', $data);                        
					return DB::execute("UPDATE ".$prefix."acal_events SET ".$res." WHERE calendar_id=".$Calendar." and event_id=".((int) $ID));                        
			}
		}

		function Delete($prefix, $Table, $Array) //, $UserID
		{
			$mas=array();
			foreach($Array as $Key=>$Val)
			{
				if(substr($Key,'time')=== true)
					$data[] = $Key."= '".DB::convert_date(DB::escape($Val))."'";
				else
					$data[] = $Key."= '".DB::escape($Val)."'";

				$mas[]=$Key."='".DB::escape($Val)."'";
			}
			$res = implode(' and ', $mas);
			DB::execute("DELETE FROM ".$prefix.$Table." WHERE ".$res); //and user_id = ".$UserID);
		}

/********EVENTS**********/

		function SelectEvents($prefix, $TimeFrom, $TimeTill, $UserID)
		{
			$UserID = (int) $UserID;
			$convertedTimeFrom = DB::convert_date(DB::escape($TimeFrom));
			$convertedTimeTill = DB::convert_date(DB::escape($TimeTill));
			$sql = "SELECT *,".DB::convert_date_as("event_timefrom").",".DB::convert_date_as("event_timetill")." 
					FROM ".$prefix."acal_events 
					WHERE ((
						(event_timefrom>=".$convertedTimeFrom." and event_timefrom<=".$convertedTimeTill.") 
						OR (event_timetill>=".$convertedTimeFrom." and event_timetill<=".$convertedTimeTill.") 
						OR (event_timefrom<=".$convertedTimeFrom." and event_timetill>=".$convertedTimeTill.")
						) and (
						calendar_id IN (SELECT calendar_id FROM ".$prefix."acal_calendars WHERE user_id=".$UserID." 
										UNION 
										SELECT id_calendar AS 'calendar_id' FROM ".$prefix."acal_sharing WHERE id_to_user=".$UserID."
										)
						))";

			return DB::query($sql);
		}
		
		function SelectSharedEvents($prefix, $TimeFrom, $TimeTill, $UserID)
		{
			$UserID = (int) $UserID;
			$convertedTimeFrom = DB::convert_date(DB::escape($TimeFrom));
			$convertedTimeTill = DB::convert_date(DB::escape($TimeTill));
			$sql = "SELECT *,".DB::convert_date_as("event_timefrom").",".DB::convert_date_as("event_timetill")." 
					FROM ".$prefix."acal_events 
					WHERE ((
						(event_timefrom>=".$convertedTimeFrom." and event_timefrom<=".$convertedTimeTill.") 
						OR (event_timetill>=".$convertedTimeFrom." and event_timetill<=".$convertedTimeTill.") 
						OR (event_timefrom<=".$convertedTimeFrom." and event_timetill>=".$convertedTimeTill.")
						) and (
						calendar_id IN (SELECT id_calendar FROM ".$prefix."acal_sharing WHERE id_to_user=".$UserID.")
						))";

			return DB::query($sql);
		}
		
		/**
		* @param string $prefix
		* @param int $calendar_id
		* @param string $name
		* @param string $text
		* @param string $dbtime_from
		* @param string $dbtime_till
		* @param bool $allday
		* @param int $priority
		* @return int
		*/
		function CreateEvent($prefix, $calendar_id, $name, $text, $dbtime_from, $dbtime_till, $allday, $priority)
		{
			$sql = 'INSERT INTO %sacal_events (calendar_id, event_timefrom, event_timetill, event_allday,
						event_name, event_text, event_priority) 
						VALUES(%d, \'%s\', \'%s\', %d, \'%s\', \'%s\', %d)';

			$sql = sprintf($sql, $prefix, $calendar_id,
									DB::escape($dbtime_from),
									DB::escape($dbtime_till),
									(int) $allday,
									DB::escape($name),
									DB::escape($text),
									(int) $priority);

			return DB::executeWithId($sql);
		}

		/**
		* @param string $prefix
		* @param int $event_id
		* @param int $calendar_id
		* @param string[optional] $name
		* @param string[optional] $text
		* @param string[optional] $dbtime_from
		* @param string[optional] $dbtime_till
		* @param bool[optional] $allday
		* @param int[optional] $priority
		* @param int[optional] $new_calendar_id
		*/
		function UpdateEvent($prefix, $event_id, $calendar_id, $name = null, $text = null, $dbtime_from = null, $dbtime_till = null, $allday = null, $priority = null, $new_calendar_id = null)
		{
			$data = array();
			if ($name !== null)
			{
				$data[] = 'event_name = \''.DB::escape($name).'\'';
			}
			if ($text !== null)
			{
				$data[] = 'event_text = \''.DB::escape($text).'\'';
			}
        	if ($dbtime_from !== null)
			{
				$data[] = 'event_timefrom = \''.DB::escape($dbtime_from).'\'';
			}
        	if ($dbtime_till !== null)
			{
				$data[] = 'event_timetill = \''.DB::escape($dbtime_till).'\'';
			}
			if ($allday !== null)
			{
				$data[] = 'event_allday = '.((int) $allday);
			}
			if ($priority !== null)
			{
				$data[] = 'event_priority = '.((int) $priority);
			}
			if ($new_calendar_id !== null && $new_calendar_id != $calendar_id)
			{
				$data[] = 'calendar_id = '.((int) $new_calendar_id);
			}

			if (count($data) > 0)
			{
				$sql = 'UPDATE %sacal_events SET %s WHERE event_id = %d AND calendar_id = %d';
				$sql = sprintf($sql, $prefix, implode(', ', $data), $event_id, $calendar_id);
				DB::execute($sql);
			}
		}

		function SelectCalendarEvents($prefix, $TimeFrom, $TimeTill, $CalendarID)
		{
			$CalendarID = (int) $CalendarID;
			$convertedTimeFrom = DB::convert_date(DB::escape($TimeFrom));
			$convertedTimeTill = DB::convert_date(DB::escape($TimeTill));
			
			$sql = "SELECT *,".DB::convert_date_as("event_timefrom").",".DB::convert_date_as("event_timetill")." 
					FROM ".$prefix."acal_events 
					WHERE ((
						(event_timefrom>=".$convertedTimeFrom." and event_timefrom<=".$convertedTimeTill.") 
						OR (event_timetill>=".$convertedTimeFrom." and event_timetill<=".$convertedTimeTill.") 
						OR (event_timefrom<=".$convertedTimeFrom." and event_timetill>=".$convertedTimeTill.")
						) and (
						calendar_id=".$CalendarID."))";

			return DB::query($sql);
		}

		function SelectAllYearEvents($prefix,$Date,$UserID) {
			$UserID = (int) $UserID;
			$sql = "SELECT DISTINCT ".DB::convert_date_as("event_timefrom").",".DB::convert_date_as("event_timetill")."   
					FROM ".$prefix."acal_events 
					WHERE (calendar_id IN (
						SELECT calendar_id FROM ".$prefix."acal_calendars WHERE user_id=".$UserID." 
						UNION 
						SELECT id_calendar AS 'calendar_id' FROM ".$prefix."acal_sharing WHERE id_to_user=".$UserID.") 
					and (YEAR(event_timefrom)=YEAR('".DB::escape($Date)."'))) ORDER BY event_timefrom ASC";
			return DB::query($sql);
		}

		function SelectCalendarYearEvents($prefix,$Date,$CalendarID) {
			$CalendarID = (int) $CalendarID;
			$sql = "SELECT DISTINCT ".DB::convert_date_as("event_timefrom").",".DB::convert_date_as("event_timetill")."   
					FROM ".$prefix."acal_events 
					WHERE (calendar_id=".$CalendarID." and (YEAR(event_timefrom)=YEAR('".DB::escape($Date)."'))) ORDER BY event_timefrom ASC";
			return DB::query($sql);
		}

		function DeleteEvent($prefix, $event_id, $calendar_id)
		{
			$event_id = (int) $event_id;
			$calendar_id = (int) $calendar_id;
			$res = DB::execute('DELETE FROM '.$prefix.'acal_events WHERE event_id = '.$event_id.' and calendar_id='.$calendar_id);
			if ($res && count($res) > 0) return true;
			else return false;
		}

		function DeleteUserEvents($prefix, $Id)
		{
			$Id = (int) $Id;
			$sql = "DELETE ".$prefix."acal_events
			FROM ".$prefix."acal_events, ".$prefix."acal_calendars 
			WHERE (".$prefix."acal_events.calendar_id = ".$prefix."acal_calendars.calendar_id AND ".$prefix."acal_calendars.user_id = ".$Id.")";
			DB::execute($sql);
		}
		

/*****CALENDAR*****/
		function SelectCalendars($prefix, $UserID, $Active)
		{
			$UserID = (int) $UserID;
			$Active = (int) $Active;
			if(!$Active)
			{
				return DB::query("SELECT cal.*, publ.str_md5 AS 'publication_hash', publ.int_access_level AS 'publication_level', shar.int_access_level AS 'sharing_level'
					FROM ".$prefix."acal_calendars AS cal
					LEFT JOIN ".$prefix."acal_publications AS publ ON (cal.calendar_id = publ.id_calendar)
					LEFT JOIN ".$prefix."acal_sharing as shar ON (cal.calendar_id = shar.id_calendar AND shar.id_to_user=".$UserID.")
					WHERE cal.calendar_id IN (
						SELECT calendar_id  FROM ".$prefix."acal_calendars WHERE user_id=".$UserID."
						UNION
						SELECT id_calendar AS 'calendar_id' FROM ".$prefix."acal_sharing WHERE id_to_user=".$UserID."
					)");
			}
			else
			{
				return DB::query("SELECT cal.*, publ.str_md5 AS 'publication_hash', publ.int_access_level AS 'publication_level', shar.int_access_level AS 'sharing_level'
					FROM ".$prefix."acal_calendars AS cal
					LEFT JOIN ".$prefix."acal_publications AS publ ON (cal.calendar_id = publ.id_calendar)
					LEFT JOIN ".$prefix."acal_sharing as shar ON (cal.calendar_id = shar.id_calendar AND shar.id_to_user=".$UserID.")
					WHERE cal.calendar_id IN (
						SELECT calendar_id  FROM ".$prefix."acal_calendars WHERE user_id=".$UserID."
						UNION
						SELECT id_calendar AS 'calendar_id' FROM ".$prefix."acal_sharing WHERE id_to_user=".$UserID."
					) AND cal.calendar_active='1'");
			}
		}
		
		function SelectSharedCalendars($prefix, $UserID, $Active)
		{
			$UserID = (int) $UserID;
			$Active = (int) $Active;
			if(!$Active)
			{
				return DB::query("SELECT cal.*, publ.str_md5 AS 'publication_hash', publ.int_access_level AS 'publication_level', shar.int_access_level AS 'sharing_level'
					FROM ".$prefix."acal_calendars AS cal
					LEFT JOIN ".$prefix."acal_publications AS publ ON (cal.calendar_id = publ.id_calendar)
					LEFT JOIN ".$prefix."acal_sharing as shar ON (cal.calendar_id = shar.id_calendar AND shar.id_to_user=".$UserID.")
					WHERE cal.calendar_id IN (
						SELECT id_calendar FROM ".$prefix."acal_sharing WHERE id_to_user=".$UserID."
					)");
			}
			else
			{
				return DB::query("SELECT cal.*, publ.str_md5 AS 'publication_hash', publ.int_access_level AS 'publication_level', shar.int_access_level AS 'sharing_level'
					FROM ".$prefix."acal_calendars AS cal
					LEFT JOIN ".$prefix."acal_publications AS publ ON (cal.calendar_id = publ.id_calendar)
					LEFT JOIN ".$prefix."acal_sharing as shar ON (cal.calendar_id = shar.id_calendar AND shar.id_to_user=".$UserID.")
					WHERE cal.calendar_id IN (
						SELECT id_calendar FROM ".$prefix."acal_sharing WHERE id_to_user=".$UserID."
					) AND cal.calendar_active='1'");
			}
		}

		function SelectPublicCalendar($prefix, $calendar_id) {
			return DB::query("SELECT cal.*, publ.int_access_level AS 'publication_level'
						FROM ".$prefix."acal_calendars AS cal
						LEFT JOIN ".$prefix."acal_publications AS publ ON (cal.calendar_id = publ.id_calendar)
						 WHERE (cal.calendar_id = ".$calendar_id.")");
		}

		/**
		* @param string $prefix
		* @param int $user_id
		* @param int $calendar_id
		* @param int $color_id
		* @param string[optional] $name
		* @param string[optional] $content
		* @param bool[optional] $active
		*/
		function UpdateCalendar($prefix, $calendar_id, $color_id, $name = null, $content = null, $active = null)
		{
			$data = array('calendar_color = '.((int) $color_id));
			if ($name !== null)
			{
				$data[] = 'calendar_name = \''.DB::escape($name).'\'';
			}
			if ($content !== null)
			{
				$data[] = 'calendar_description = \''.DB::escape($content).'\'';
			}
			if ($active !== null)
			{
				$data[] = 'calendar_active = '.intval($active);
			}

			$sql = 'UPDATE %sacal_calendars SET %s WHERE calendar_id = %d';
			$sql = sprintf($sql, $prefix, implode(', ', $data), $calendar_id);
			DB::execute($sql);
		}

		/**
		* @param string $prefix
		* @param int $user_id
		* @param int $calendar_id
		* @param int $color_id
		* @param string $name
		* @param string $content
		* @param bool $active
		* @return int
		*/
		function CreateCalendar($prefix, $user_id, $color_id, $name, $content, $active)
		{
			$sql = 'INSERT INTO %sacal_calendars (user_id, calendar_name, calendar_description, calendar_color, calendar_active) 
						VALUES (%d, \'%s\', \'%s\', %d, %d)';
			$sql = sprintf($sql, $prefix, $user_id, DB::escape($name), DB::escape($content), $color_id, $active);
			return DB::executeWithId($sql);
		}


		/*
		* @param string $prefix
		* @param int $calendar_id
		* @param int $user_id
		* return bool - true if user_id has calendar_id, else overwise
		*/
		function CheckUserCalendarsById($prefix, $calendar_id, $user_id)
		{
			$sql = 'SELECT calendar_id FROM %sacal_calendars 
					WHERE calendar_id=%d AND user_id=%d';
			$sql = sprintf($sql, $prefix, $calendar_id, $user_id);
			$res = DB::query($sql);
			return ($res && count($res) > 0);
		}
		/*
		* @param string $prefix
		* @param int $calendar_id
		* @param int $user_id
		* return query result
		*/
		function CheckSharedCalendarsById($prefix, $calendar_id, $user_id)
		{
			$sql = 'SELECT int_access_level FROM %sacal_sharing
					WHERE id_calendar=%d AND id_to_user=%d';
			$sql = sprintf($sql, $prefix, $calendar_id, $user_id);
			$res = DB::query($sql);
			return $res;
		}

		function GetCalendarParametersByHash($prefix,$hash)
		{
			$sql = 'SELECT publ.id_calendar, publ.id_user, publ.int_access_level, cal.calendar_name  FROM %sacal_publications AS publ 
					LEFT JOIN %sacal_calendars AS cal ON (publ.id_calendar = cal.calendar_id) 
					WHERE publ.str_md5=\'%s\'';
			$sql = sprintf($sql, $prefix, $prefix, $hash);
			$res = DB::query($sql);
			if ($res && count($res) > 0) return $res;
			else return false;
		}

		function DeleteCalendar($prefix, $calendar_id)
		{
			$calendar_id = (int) $calendar_id;
			DB::execute('DELETE FROM '.$prefix.'acal_events WHERE calendar_id = '.$calendar_id);
			DB::execute('DELETE FROM '.$prefix.'acal_calendars WHERE calendar_id = '.$calendar_id);
			DB::execute('DELETE FROM '.$prefix.'acal_publications WHERE id_calendar = '.$calendar_id);
			DB::execute('DELETE FROM '.$prefix.'acal_sharing WHERE id_calendar = '.$calendar_id);
		}


/***********PUBLICATION*************/
		/**
		* @param string $prefix
		* @param string $hash
		* @return string
		**/
		function SelectPublication($prefix,$hash) {
			$sql = 'SELECT id_publication FROM %sacal_publications WHERE str_md5=\'%s\'';
			$sql = sprintf($sql, $prefix, $hash);
			return DB::query($sql);
		}
		
		/**
		* @param string $prefix
		* @param int $user_id
		* @param int $calendar_id
		* @param int $publication_level
		**/
		function CreatePublication($prefix, $user_id, $calendar_id, $str_md5, $publication_level)
		{
			$user_id = (int) $user_id;
			$calendar_id = (int) $calendar_id;
			$str_md5 = DB::escape($str_md5);
			$publication_level = (int) $publication_level;
			$sql = 'SELECT id_publication FROM '.$prefix.'acal_publications WHERE (id_user='.$user_id.' AND id_calendar='.$calendar_id.')';
			$res = DB::query($sql);
			if ($res && count($res)!=0) {
				$id_publication = $res[0]['id_publication'];
				$sql = "UPDATE ".$prefix."acal_publications SET str_md5='".$str_md5."', int_access_level=".$publication_level." 
				WHERE id_user=".$user_id." AND id_calendar=".$calendar_id;
				DB::execute($sql);
				return $id_publication;
			} else {
				$sql = "INSERT INTO ".$prefix."acal_publications (id_user, id_calendar, str_md5, int_access_level) 
					VALUES (".$user_id.", ".$calendar_id.", '".$str_md5."', ".$publication_level.")";
				return DB::executeWithId($sql);
			}
		}
		/**
		* @param string $prefix
		* @param int $calendar_id
		**/
		function DeletePublication($prefix, $calendar_id)
		{
			$sql = 'DELETE FROM %sacal_publications WHERE id_calendar=%d';
			$sql = sprintf($sql, $prefix, $calendar_id);
			return DB::execute($sql);
		}


/*************SHARE***************/
		function CheckShareExist($prefix, $user_id, $calendar_id) {
			$sql = 'SELECT id_share FROM %sacal_sharing WHERE id_to_user=%d AND id_calendar=%d';
			$sql = sprintf($sql, $prefix, $user_id, $calendar_id);
			return DB::execute($sql);
		}
		/**
		* @param string $prefix
		* @param int $user_id
		* @param int $calendar_id
		* @param int $to_user
		* @param int $permission
		**/
		function CreateShare($prefix, $user_id, $calendar_id, $toUser_id, $toUser_email, $permission) {
			$sql = 'INSERT INTO %sacal_sharing (id_user, id_calendar, id_to_user, str_to_email, int_access_level) 
					VALUES (%d, %d, %d, \'%s\', %d)';
			$sql = sprintf($sql, $prefix, $user_id, $calendar_id, $toUser_id, $toUser_email, $permission);
			return DB::execute($sql);
		}
		/**
		* @param string $prefix
		* @param int $share_id
		* @param int $permission
		**/
		function UpdateShare($prefix, $share_id, $permission) {
			$sql = "UPDATE %sacal_sharing SET int_access_level=%d WHERE id_share=%d";
			$sql = sprintf($sql, $prefix, $permission, $share_id);
			return DB::execute($sql);
		}
		/**
		* @param string $prefix
		* @param int $calendar_id
		**/
		function SelectShare($prefix, $calendar_id) {
			$sql = "SELECT id_share, id_to_user, str_to_email AS email_to_user, int_access_level FROM %sacal_sharing WHERE id_calendar=%d";
			$sql = sprintf($sql, $prefix, $calendar_id);
			return DB::query($sql);
		}
		/**
		* @param string $prefix
		* @param int $calendar_id
		* @param int $share_id
		**/
		function DeleteShare($prefix, $calendar_id, $share_id)
		{
			$sql = 'DELETE FROM %sacal_sharing WHERE id_calendar=%d AND id_share=%d';
			$sql = sprintf($sql, $prefix, $calendar_id, $share_id);
			DB::execute($sql);
		}
		/**
		* @param string $prefix
		* @param string $email
		* @param int $user_id
		**/
		function CheckUserAccountIsMultiuser($prefix, $email) //check if this email  is multiuser. Return 0 if bd has no this user, 1 - one user in db, 2 and more - a few accounts has this email
		{
			$sql = 'SELECT id_user FROM %sawm_accounts WHERE email=\'%s\'';
			$sql = sprintf($sql, $prefix, $email);
			return DB::execute($sql);
		}

}?>