<?php

/*
 * AfterLogic WebMail Pro PHP by AfterLogic Corp. <support@afterlogic.com>
 *
 * Copyright (C) 2002-2009  AfterLogic Corp. (www.afterlogic.com)
 * Distributed under the terms of the proprietary AfterLogic Computer License (LICENSE.txt)
 * 
 */

	@ini_set('max_execution_time', 120);
	@ini_set('memory_limit', '50M');
	@set_time_limit(120);
	@ini_set('display_errors', 'Off');
	@ignore_user_abort(true);
	
	define('TIME2RUN', 10800);
	define('TIME2KILL', 10800);
	define('TIME2KILLFILE', 'clear_time.txt');
	
	if (!defined('WM_ROOTPATH')) 
	{
		define('WM_ROOTPATH', (dirname(__FILE__).'/'));
	}
	
	require_once(WM_ROOTPATH.'class_settings.php');
	
	$_temp_path = INI_DIR.'/temp';

	Run($_temp_path);
	
	/* ------------------------------------------- */
	
	function Run($_temp_path)
	{
		if (is_dir($_temp_path))
		{
			$_now = time();
			$_time = _getTimeFromTimeFile($_temp_path.'/'.TIME2KILLFILE);
	
			if ($_time === -1 || $_now - $_time > TIME2RUN)	
			{
				_deleteDir($_temp_path);
				_saveTime($_temp_path);
			}
			
			return true;
		}
		
		return false;
	}
	
	function _saveTime($path)
	{
		if (is_dir($path))
		{
			return _saveTimeFile($path.'/'.TIME2KILLFILE);
		}
		else 
		{
			if (@mkdir($path))
			{
				return _saveTimeFile($path.'/'.TIME2KILLFILE);
			}
			else 
			{
				echo 'Error: can\'t create folder '.$path;
			}
		}
		
		return false;
	}
	
	function _getTimeFromTimeFile($filename)
	{
		$_time = -1;
		if (file_exists($filename))
		{
			$_time = (int) file_get_contents($filename);
		}
		return $_time;
	}
	
	function _saveTimeFile($filename)
	{
		$handle = @fopen($filename, 'wb');
		if ($handle)
		{
			$result = @fwrite($handle, time()) !== false;
			$result = @fclose($handle);
			return $result;
		}
		
		return false;
	}
	
	function _clearDir($path)
	{
		$now = time();
		$isNull = true;
		if (is_dir($path))
		{
			$dh = @opendir($path);
			if ($dh)
			{
				while (($file = @readdir($dh)) !== false)
				{
					if ($file != '.' && $file != '..')
					{
						if ($now - filemtime($path.'/'.$file) > TIME2KILL)
						{
							@unlink($path.'/'.$file);	
						}
						else 
						{
							$isNull = false;
						}
					} 
				}
				@closedir($dh);
			}
		}
		return $isNull;
	}
	
	function _deleteDir($path)
	{
		$count = 0;
		
		if (is_dir($path))
		{
			$dh = @opendir($path);
			if ($dh)
			{
				while (($file = @readdir($dh)) !== false)
				{
					if ($file != '.' && $file != '..')
					{
						if (is_dir($path.'/'.$file))
						{
							_deleteDir($path.'/'.$file);
						}
						else 
						{
							$count++;	
						}
					} 
				}
				@closedir($dh);
			}
			if ($count > 0)
			{
				if (_clearDir($path))
				{
					@rmdir($path);
				}
			}
			else 
			{
				@rmdir($path);
			}
		}
	}
	